% Voir livre Perron et Munger: Analyse des systèmes et matrice d'état et exercices multi-physiques 2022 
% REMARQUE AU LECTEUR: LE MODÈLE SUGGÉRÉ EST UN EXEMPLE ACCADÉMIQUE.  
% TOUTES AUTRES APPLICATIONS EST AU RISQUE DE L'UTILISATEUR

% Problème : La filtration par membrane
close all, clear all, clc      

%% Parametres du probleme
h1 = 1;             % Hauteur du réservoir 1 [m]
h2 = 1;             % Hauteur du réservoir 2 [m]
R1 = 15;            % Résistance à l'écoulement du fluide 1	[m/m^3 s]
R2 = 30;            % Résistance à l'écoulement du fluide 2	[m/m^3 s]
S1 = 1;             % Surface du réservoir 1 [m]
S2 = 1;             % Sufface du réservoir 2 [m2]

%% Question 1 : Trouver l'équation d'état
syms a1 a2 a3 b1
a1 = -1/(S1*R1);
a2 = 1/(S2*R1);
a3 = -1/(S2*R2);
b1 = 1/S1;

matA = [a1 0; a2 a3];   % Matrice d'etat
matB = [b1; 0];          % Matrice de controle

%% Question 2 : Trouver le résolvant
syms s t
Identite = eye(2);              % Matrice identité [2x2]
Phi = inv(s*Identite-matA);     % Inverse la matrice 

%% Question 3 : Trouver les fonctions de transfert G1(s) = h1/mi et G2(s) = h2/mi
GS = Phi*matB;
G1S = GS(1);
G2S = GS(2);

%% Question 4 : Trouver h1(t) et h2(t)
h1_0 = 0;
h2_0 = 0;
mi = 1/30;
C1 = [1 0];
C2 = [0 1];
uS = [mi/s];
xi = [h1_0;h2_0];

h1S = C1*Phi*(xi+matB*uS);
h2S = C2*Phi*(xi+matB*uS);

h1T = ilaplace(h1S,t);
h2T = ilaplace(h2S,t);

temps = linspace(0,250,10000);

h1Taff = subs(h1T,t,temps);
h2Taff = subs(h2T,t,temps);

maxh1 = max(h1Taff);
maxh2 = max(h2Taff);

figure (1)
hold on
plot(temps,h1Taff)
xlabel('Temps (s)')
ylabel('Niveau du réservoir (m)')
title('Évolution du niveau du réservoir 1')
grid on
hold off 

figure (2)
hold on
plot(temps,h2Taff)
xlabel('Temps (s)')
ylabel('Niveau du réservoir (m)')
title('Évolution du niveau du réservoir 2')
grid on
hold off

%% Question 5 : Trouver le temps pour remplir le réservoir 2 au maximum.
sol = solve(h2T==0.999*h2,t);

%% Question 6 : Trouver le temps total du traitement de 10 [m^3] d'eau.
delais = sol(2);
uS = [mi/s-mi*exp(-delais*s)/s];
xi = [0;0];

h1S2 = C1*Phi*(xi+matB.*uS);
h2S2 = C2*Phi*(xi+matB.*uS);

h1T2 = ilaplace(h1S2,t);
h2T2 = ilaplace(h2S2,t);

sol2 = solve(h2T2==0.05*h2,t); 
 
temps = linspace(0,400,1000);

h1Taff2 = subs(h1T2,t,temps);
h2Taff2 = subs(h2T2,t,temps);

figure (3)
hold on
plot(temps,h1Taff2)
xlabel('Temps (s)')
ylabel('Niveau du réservoir (m)')
title('Évolution du niveau du réservoir 1')
grid on
hold off 

figure (4)
hold on
plot(temps,h2Taff2)
xlabel('Temps (s)')
ylabel('Niveau du réservoir (m)')
title('Évolution du niveau du réservoir 2')
grid on
hold off 

%% Question 6 : 
% syms mi t 
% h2T = (a2*b1*mi)/(a1*a3) + (a2*b1*mi*exp(a1*t))/(a1*(a1 - a3)) - (a2*b1*mi*exp(a3*t))/(a3*(a1 - a3));
% h2T = subs(h2T,t,inf);
% 
% sol3 = solve(h2T==h2,mi)