% Voir livre Perron et Munger: Analyse des systèmes et matrice d'état et exercices multi-physiques 2022 
% REMARQUE AU LECTEUR: LE MODÈLE SUGGÉRÉ EST UN EXEMPLE ACCADÉMIQUE.  
% TOUTES AUTRES APPLICATIONS EST AU RISQUE DE L'UTILISATEUR

% Problème : Le malaxeur
close all, clear all, clc      

%% Parametres du probleme
A = 1;              % Surface du liquide [m^2]
E = 100;            % Tension [V]
h0 = 1;             % Hauteur initiale [m]
I = 10;             % Courant [A]
J = 0.125;          % Inertie [kgm^2]
k1 = 0.2618;        % Constante de couplage [Nm/A]
k2 = 0.2618;        % Constante de couplage [Vs/rad]
k3 = 8;             % Constante pour la friction [N]
k4 = 0.02;          % Constante pour la friction [Nms/rad]
k5 = 0.1;           % Constante pour la friction [m^2/s] 
k6 = 20;            % Gain P [Vs/rad]
R = 7.259;          % Résistance [ohm]

%% Question 1 : Trouver l'équation d'état
syms a1 a2 a3 b1
a1 = -((k1*k2)/(J*R)+k4/J);
a2 = -k3/J;
a3 = -k5/A;
b1 = k1/(J*R);

matA = [0 1 0;0 a1 a2;0 0 a3];    % Matrice d'etat
matB = [0;b1;0];                  % Matrice de controle

%% Question 2 : Trouver le résolvant
syms s t
Identite = eye(3);              % Matrice identité [2x2]
Phi = inv(s*Identite-matA);     % Inverse la matrice 

%% Question 3 : Trouver les expressions de omega(t) et h(t)
%syms E h0;
C2 = [0 1 0];
C3 = [0 0 1];
uS = [E/s];
xi = [0; 0 ;1];

omegaS = C2*Phi*(xi+matB*uS);
hS = C3*Phi*(xi+matB*uS);

omegaT = ilaplace(omegaS,t);
hT = ilaplace(hS,t);

temps = linspace(0,100,1000);
omegaTaff = subs(omegaT,t,temps);
hTaff = subs(hT,t,temps);

figure (1)
hold on
plot(temps,omegaTaff)
xlabel('Temps (s)')
ylabel('Vitesse (rad/s)')
title('Évolution de la vitesse de rotation')
grid on
hold off

figure(2)
hold on
plot(temps,hTaff)
xlabel('Temps (s)')
ylabel('Niveau du liquide (m)')
title('Évolution du niveau du liquide')
grid on
hold off


%% Question 4 : Trouver l'expression de la fonction de transfert en boucle fermée

%syms k6 omegaMoy
G1 = C2*Phi*matB;
Gbf = (k6*G1)/(1+(k6*G1));

%% Question 5 : Trouver l'expression de la vitesse en boucle fermée
omegaMoy = 4.08;
omegaMoyT = omegaMoy*t;
omegaMoyS = laplace(omegaMoyT);

omegaS = Gbf*omegaMoyS;
omegaTbf = ilaplace(omegaS,t);

%% Question 6 : Tracer l'évolution de la vitesse en boucle fermée

omegaTbfaff = subs(omegaTbf,t,temps);
omegaMoyTaff = subs(omegaMoyT,t,temps);

figure (1)
hold on
plot(temps,omegaTbfaff)
plot(temps,omegaMoyTaff,'--')
xlabel('Temps (s)')
ylabel('Vitesse (rad/s)')
title('Évolution de la vitesse de rotation en boucle fermée')
legend('Vitesse de rotation','Vitesse de référence')
grid on
hold off
